local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

local buff = x.Buff
local cooldown = x.Cooldown
local dot = x.Dot
local talent = x.Talent
local target = x.Target

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()

	s.UpdateTarget()
	x.InCombat = s.InCombat()
	x.GCD = s.GlobalCooldown()
	x.Spec = s.TalentMastery()
	x.MaxHealth = s.MaxHealth("player")
	x.Health = s.Health("player")
	x.HealthPercent = s.HealthPercent("player")
	x.ActiveEnemies = s.SpellTargets()
	x.MaxGCD = math.max(1, 150 / (100 + UnitSpellHaste("player")))
	x.UseLongCD = s.UseLongCD()

	x.ManaPercent = s.PowerPercent("player", Enum.PowerType.Mana)
	x.SoulShards = s.MyPower(Enum.PowerType.SoulShards)
	
	if x.Spec == 1 then
		-- Affliction

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.EnemyDetected then
			a.Flash(
				"flask"
				,"food"
				,"augmentation"
				,"summon_pet"
				,"grimoire_of_sacrifice,if=talent.grimoire_of_sacrifice.enabled"
				,"potion"
				,"seed_of_corruption,if=spell_targets.seed_of_corruption_aoe>=3"
				,"haunt"
				,"shadow_bolt,if=!talent.haunt.enabled&spell_targets.seed_of_corruption_aoe<3"
			)
		end
--[[
-- Executed every time the actor is available.
,"variable,name=use_seed,value=talent.sow_the_seeds.enabled&spell_targets.seed_of_corruption_aoe>=3|talent.siphon_life.enabled&spell_targets.seed_of_corruption>=5|spell_targets.seed_of_corruption>=8"
,"variable,name=padding,op=set,value=action.shadow_bolt.execute_time*azerite.cascading_calamity.enabled"
,"variable,name=padding,op=reset,value=gcd,if=azerite.cascading_calamity.enabled&(talent.drain_soul.enabled|talent.deathbolt.enabled&cooldown.deathbolt.remains<=gcd)"
,"call_action_list,name=cooldowns"
,"drain_soul,interrupt_global=1,chain=1,cycle_targets=1,if=target.time_to_die<=gcd&soul_shard<5"
,"haunt,if=spell_targets.seed_of_corruption_aoe<=2"
,"summon_darkglare,if=dot.agony.ticking&dot.corruption.ticking&(buff.active_uas.stack=5|soul_shard=0)&(!talent.phantom_singularity.enabled|cooldown.phantom_singularity.remains)"
,"agony,target_if=min:dot.agony.remains,if=remains<=gcd+action.shadow_bolt.execute_time&target.time_to_die>8"
,"unstable_affliction,target_if=!contagion&target.time_to_die<=8"
,"drain_soul,target_if=min:debuff.shadow_embrace.remains,interrupt_immediate=1,interrupt_if=ticks_remain<5,if=talent.shadow_embrace.enabled&active_enemies<=2&debuff.shadow_embrace.remains&debuff.shadow_embrace.remains<=gcd*2"
,"shadow_bolt,target_if=min:debuff.shadow_embrace.remains,if=talent.shadow_embrace.enabled&talent.absolute_corruption.enabled&active_enemies<=2&debuff.shadow_embrace.remains&debuff.shadow_embrace.remains<=execute_time*2+travel_time&!action.shadow_bolt.in_flight"
,"phantom_singularity,target_if=max:target.time_to_die,if=time>35&(cooldown.summon_darkglare.remains>=45|cooldown.summon_darkglare.remains<8)&target.time_to_die>16*spell_haste"
,"vile_taint,target_if=max:target.time_to_die,if=time>15&target.time_to_die>=10"
,"unstable_affliction,if=!variable.use_seed&soul_shard=5"
,"seed_of_corruption,if=variable.use_seed&soul_shard=5"
,"call_action_list,name=dots"
,"phantom_singularity,if=time<=35"
,"vile_taint,if=time<15"
,"dark_soul"
,"berserking"
,"call_action_list,name=spenders"
,"call_action_list,name=fillers"

-- Cooldowns
,"potion,if=(talent.dark_soul_misery.enabled&cooldown.summon_darkglare.up&cooldown.dark_soul.up)|cooldown.summon_darkglare.up|target.time_to_die<30"
,"use_items,if=!cooldown.summon_darkglare.up"
,"fireblood,if=!cooldown.summon_darkglare.up"
,"blood_fury,if=!cooldown.summon_darkglare.up"

-- Dots
,"seed_of_corruption,if=dot.corruption.remains<=action.seed_of_corruption.cast_time+time_to_shard+4.2*(1-talent.creeping_death.enabled*0.15)&spell_targets.seed_of_corruption_aoe>=3+talent.writhe_in_agony.enabled&!dot.seed_of_corruption.remains&!action.seed_of_corruption.in_flight"
,"agony,target_if=min:remains,if=talent.creeping_death.enabled&active_dot.agony<6&target.time_to_die>10&(remains<=gcd|cooldown.summon_darkglare.remains>10&refreshable)"
,"agony,target_if=min:remains,if=!talent.creeping_death.enabled&active_dot.agony<8&target.time_to_die>10&(remains<=gcd|cooldown.summon_darkglare.remains>10&refreshable)"
,"siphon_life,target_if=min:remains,if=-spell_targets.sow_the_seeds_aoe<5&target.time_to_die>10&refreshable&!(cooldown.summon_darkglare.remains<=soul_shard*action.unstable_affliction.execute_time)"
,"siphon_life,target_if=min:remains,if=(active_dot.siphon_life<8-talent.creeping_death.enabled-spell_targets.sow_the_seeds_aoe)&target.time_to_die>10&refreshable&!(cooldown.summon_darkglare.remains<=soul_shard*action.unstable_affliction.execute_time)"
,"corruption,cycle_targets=1,if=active_enemies<3+talent.writhe_in_agony.enabled&(remains<=gcd|cooldown.summon_darkglare.remains>10&refreshable)&target.time_to_die>10"

-- Fillers
,"agony,if=talent.deathbolt.enabled&cooldown.summon_darkglare.remains>=30+gcd&cooldown.deathbolt.remains<=gcd&!prev_gcd.1.summon_darkglare&!prev_gcd.1.agony&talent.writhe_in_agony.enabled&azerite.sudden_onset.enabled&remains<duration*0.5"
,"deathbolt,if=cooldown.summon_darkglare.remains>=30+gcd|cooldown.summon_darkglare.remains>140"
,"shadow_bolt,if=buff.movement.up&buff.nightfall.remains"
,"agony,if=buff.movement.up&!(talent.siphon_life.enabled&(prev_gcd.1.agony&prev_gcd.2.agony&prev_gcd.3.agony)|prev_gcd.1.agony)"
,"siphon_life,if=buff.movement.up&!(prev_gcd.1.siphon_life&prev_gcd.2.siphon_life&prev_gcd.3.siphon_life)"
,"corruption,if=buff.movement.up&!prev_gcd.1.corruption&!talent.absolute_corruption.enabled"
,"drain_life,if=(buff.inevitable_demise.stack>=90&(cooldown.deathbolt.remains>execute_time|!talent.deathbolt.enabled)&(cooldown.phantom_singularity.remains>execute_time|!talent.phantom_singularity.enabled)&(cooldown.dark_soul.remains>execute_time|!talent.dark_soul_misery.enabled)&(cooldown.vile_taint.remains>execute_time|!talent.vile_taint.enabled)&cooldown.summon_darkglare.remains>execute_time+10|buff.inevitable_demise.stack>30&target.time_to_die<=10)"
,"haunt"
,"drain_soul,interrupt_global=1,chain=1,interrupt=1,cycle_targets=1,if=target.time_to_die<=gcd"
,"drain_soul,target_if=min:debuff.shadow_embrace.remains,chain=1,interrupt_if=ticks_remain<5,interrupt_global=1,if=talent.shadow_embrace.enabled&active_enemies=2&!debuff.shadow_embrace.remains"
,"drain_soul,target_if=min:debuff.shadow_embrace.remains,chain=1,interrupt_if=ticks_remain<5,interrupt_global=1,if=talent.shadow_embrace.enabled&active_enemies=2"
,"drain_soul,interrupt_global=1,chain=1,interrupt=1"
,"shadow_bolt,cycle_targets=1,if=talent.shadow_embrace.enabled&talent.absolute_corruption.enabled&active_enemies=2&!debuff.shadow_embrace.remains&!action.shadow_bolt.in_flight"
,"shadow_bolt,target_if=min:debuff.shadow_embrace.remains,if=talent.shadow_embrace.enabled&talent.absolute_corruption.enabled&active_enemies=2"
,"shadow_bolt"

-- Spenders
,"unstable_affliction,if=cooldown.summon_darkglare.remains<=soul_shard*execute_time"
,"call_action_list,name=fillers,if=(cooldown.summon_darkglare.remains<time_to_shard*(5-soul_shard)|cooldown.summon_darkglare.up)&time_to_die>cooldown.summon_darkglare.remains"
,"seed_of_corruption,if=variable.use_seed"
,"unstable_affliction,if=!variable.use_seed&!prev_gcd.1.summon_darkglare&(talent.deathbolt.enabled&cooldown.deathbolt.remains<=execute_time&!azerite.cascading_calamity.enabled|soul_shard>=2&target.time_to_die>4+execute_time&active_enemies=1|target.time_to_die<=8+execute_time*soul_shard)"
,"unstable_affliction,if=!variable.use_seed&contagion<=cast_time+variable.padding"
,"unstable_affliction,cycle_targets=1,if=!variable.use_seed&(!talent.deathbolt.enabled|cooldown.deathbolt.remains>time_to_shard|soul_shard>1)&contagion<=cast_time+variable.padding&(!azerite.cascading_calamity.enabled|buff.cascading_calamity.remains>time_to_shard)"
]]
	elseif x.Spec == 2 then
		-- Demonology

		buff.wild_imps.stack = a.wild_imp_count()

		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.EnemyDetected and not s.Casting(264178--[[Demonbolt]], "player") then
			a.Flash(
				"flask"
				,"food"
				,"augmentation"
				,"summon_pet"
				,"potion"
				,"demonbolt"
			)
			return
		end

		-- Executed every time the actor is available.
		s.UpdateBuff(265273, "Demonic Power")
		a.Flash(
			"potion,if=pet.demonic_tyrant.active|target.time_to_die<30"
--			,"use_items,if=pet.demonic_tyrant.active|target.time_to_die<=15"
			,"berserking,if=pet.demonic_tyrant.active|target.time_to_die<=15"
			,"blood_fury,if=pet.demonic_tyrant.active|target.time_to_die<=15"
			,"fireblood,if=pet.demonic_tyrant.active|target.time_to_die<=15"
		)

		s.UpdateDoT(265412, "Doom")
		if a.Flash(
			"doom,if=!ticking&time_to_die>30&spell_targets.implosion<2"
			,"demonic_strength,if=(buff.wild_imps.stack<6|buff.demonic_power.up)|spell_targets.implosion<2"
		) then
			return
		end

		s.UpdateBuff(264173, "Demonic Core")
		s.UpdateBuff(205146, "Demonic Calling")
		s.UpdateCooldown(265187, "Summon Demonic Tyrant")
		s.UpdateCooldown(104316, "Call Dreadstalkers")
		buff.dreadstalkers.remains = cooldown.call_dreadstalkers.remains - 8
		s.UpdateCooldown(267217, "Nether Portal")
		s.UpdateCastTime(686, "Shadow Bolt")
		s.UpdateCastTime(264178, "Demonbolt")
		s.UpdateCastTime(265187, "Summon Demonic Tyrant")
		-- "call_action_list,name=nether_portal,if=talent.nether_portal.enabled&spell_targets.implosion<=2"
		if talent.nether_portal.enabled and x.UseLongCD and x.ActiveEnemies <= 2 then
			-- Nether Portal
			-- "call_action_list,name=nether_portal_building,if=cooldown.nether_portal.remains<20"
			if cooldown.nether_portal.remains < 20 then
				-- Nether Portal Building
				if a.Flash(
					"nether_portal,if=soul_shard>=5&(!talent.power_siphon.enabled|buff.demonic_core.up)"
					,"call_dreadstalkers"
					,"hand_of_guldan,if=cooldown.call_dreadstalkers.remains>18&soul_shard>=3"
					,"power_siphon,if=buff.wild_imps.stack>=2&buff.demonic_core.stack<=2&buff.demonic_power.down&soul_shard>=3"
					,"hand_of_guldan,if=soul_shard>=5"
				) then
					return
				else
					return a.BuildAShard()
				end
			end
			-- "call_action_list,name=nether_portal_active,if=cooldown.nether_portal.remains>160"
			if cooldown.nether_portal.remains > 160 then
				-- Nether Portal Active
				if a.Flash(
					"grimoire_felguard,if=cooldown.summon_demonic_tyrant.remains<13|!equipped.132369"
					,"summon_vilefiend,if=cooldown.summon_demonic_tyrant.remains>40|cooldown.summon_demonic_tyrant.remains<12"
					,"call_dreadstalkers,if=(cooldown.summon_demonic_tyrant.remains<9&buff.demonic_calling.remains)|(cooldown.summon_demonic_tyrant.remains<11&!buff.demonic_calling.remains)|cooldown.summon_demonic_tyrant.remains>14") then
					return
				end

				if x.SoulShards == 1 and (cooldown.call_dreadstalkers.remains < action.shadow_bolt.cast_time or (talent.bilescourge_bombers.enabled and cooldown.bilescourge_bombers.remains < action.shadow_bolt.cast_time)) then
					return a.BuildAShard()
				end

				s.UpdateBuff(267218, "Nether Portal")
				if a.Flash(
					"hand_of_guldan,if=((cooldown.call_dreadstalkers.remains>action.demonbolt.cast_time)&(cooldown.call_dreadstalkers.remains>action.shadow_bolt.cast_time))&cooldown.nether_portal.remains>(160+action.hand_of_guldan.cast_time)"
					,"summon_demonic_tyrant,if=buff.nether_portal.remains<10&soul_shard=0"
					,"summon_demonic_tyrant,if=buff.nether_portal.remains<action.summon_demonic_tyrant.cast_time+5.5"
					,"demonbolt,if=buff.demonic_core.up"
				) then
					return
				else
					return a.BuildAShard()
				end
			end
		end

		-- "call_action_list,name=implosion,if=spell_targets.implosion>1"
		if x.ActiveEnemies > 1 then
			-- Implosion
			if a.Flash(
				"implosion,if=(buff.wild_imps.stack>=6&(soul_shard<3|prev_gcd.1.call_dreadstalkers|buff.wild_imps.stack>=9|prev_gcd.1.bilescourge_bombers|(!prev_gcd.1.hand_of_guldan&!prev_gcd.2.hand_of_guldan))&!prev_gcd.1.hand_of_guldan&!prev_gcd.2.hand_of_guldan&buff.demonic_power.down)|(time_to_die<3&buff.wild_imps.stack>0)|(prev_gcd.2.call_dreadstalkers&buff.wild_imps.stack>2&!talent.demonic_calling.enabled)"
				,"grimoire_felguard,if=cooldown.summon_demonic_tyrant.remains<13|!equipped.132369"
				,"call_dreadstalkers,if=(cooldown.summon_demonic_tyrant.remains<9&buff.demonic_calling.remains)|(cooldown.summon_demonic_tyrant.remains<11&!buff.demonic_calling.remains)|cooldown.summon_demonic_tyrant.remains>14"
				,"summon_demonic_tyrant"
				,"hand_of_guldan,if=soul_shard>=5"
				,"hand_of_guldan,if=soul_shard>=3&(((prev_gcd.2.hand_of_guldan|buff.wild_imps.stack>=3)&buff.wild_imps.stack<9)|cooldown.summon_demonic_tyrant.remains<=gcd*2|buff.demonic_power.remains>gcd*2)"
				,"demonbolt,if=prev_gcd.1.hand_of_guldan&soul_shard>=1&(buff.wild_imps.stack<=3|prev_gcd.3.hand_of_guldan)&soul_shard<4&buff.demonic_core.up"
				,"summon_vilefiend,if=(cooldown.summon_demonic_tyrant.remains>40&spell_targets.implosion<=2)|cooldown.summon_demonic_tyrant.remains<12"
				,"bilescourge_bombers,if=cooldown.summon_demonic_tyrant.remains>9"
				,"soul_strike,if=soul_shard<5&buff.demonic_core.stack<=2"
				,"demonbolt,if=soul_shard<=3&buff.demonic_core.up&(buff.demonic_core.stack>=3|buff.demonic_core.remains<=gcd*5.7)"
				,"doom,cycle_targets=1,max_cycle_targets=7,if=refreshable"
			) then
				return
			else
				return a.BuildAShard()
			end
		end

		s.UpdateCooldown(264119, "Summon Vilefiend")
		s.UpdateCooldown(111898, "Grimoire: Felguard")
		buff.grimoire_felguard.remains = cooldown.grimoire_felguard.remains - 105
		if a.Flash(
			"grimoire_felguard,if=cooldown.summon_demonic_tyrant.remains<13|!equipped.132369"
			,"summon_vilefiend,if=equipped.132369|cooldown.summon_demonic_tyrant.remains>40|cooldown.summon_demonic_tyrant.remains<12"
			,"call_dreadstalkers,if=equipped.132369|(cooldown.summon_demonic_tyrant.remains<9&buff.demonic_calling.remains)|(cooldown.summon_demonic_tyrant.remains<11&!buff.demonic_calling.remains)|cooldown.summon_demonic_tyrant.remains>14"
			,"summon_demonic_tyrant,if=equipped.132369|(buff.dreadstalkers.remains>cast_time&(buff.wild_imps.stack>=3|prev_gcd.1.hand_of_guldan)&(soul_shard<3|buff.dreadstalkers.remains<gcd*2.7|buff.grimoire_felguard.remains<gcd*2.7))"
			,"power_siphon,if=buff.wild_imps.stack>=2&buff.demonic_core.stack<=2&buff.demonic_power.down&spell_targets.implosion<2"
			,"doom,if=talent.doom.enabled&refreshable&time_to_die>(dot.doom.remains+30)"
			,"hand_of_guldan,if=soul_shard>=5|(soul_shard>=3&cooldown.call_dreadstalkers.remains>4&(!talent.summon_vilefiend.enabled|cooldown.summon_vilefiend.remains>3))"
			,"soul_strike,if=soul_shard<5&buff.demonic_core.stack<=2"
			,"demonbolt,if=soul_shard<=3&buff.demonic_core.up&((cooldown.summon_demonic_tyrant.remains<10|cooldown.summon_demonic_tyrant.remains>22)|buff.demonic_core.stack>=3|buff.demonic_core.remains<5|time_to_die<25)"
		) then
			return
		else
			return a.BuildAShard()
		end

	else
		-- Destruction
--[[
		-- Executed before combat begins. Accepts non-harmful actions only.
		if not x.InCombat and x.EnemyDetected then
			a.Flash(
				"flask"
				,"food"
				,"augmentation"
				,"summon_pet"
				,"grimoire_of_sacrifice,if=talent.grimoire_of_sacrifice.enabled"
				,"potion"
				,"soul_fire"
				,"incinerate,if=!talent.soul_fire.enabled"
			)
		end

-- Executed every time the actor is available.
,"run_action_list,name=cata,if=spell_targets.infernal_awakening>=3&talent.cataclysm.enabled"
,"run_action_list,name=fnb,if=spell_targets.infernal_awakening>=3&talent.fire_and_brimstone.enabled"
,"run_action_list,name=inf,if=spell_targets.infernal_awakening>=3&talent.inferno.enabled"
,"cataclysm"
,"immolate,cycle_targets=1,if=!debuff.havoc.remains&(refreshable|talent.internal_combustion.enabled&action.chaos_bolt.in_flight&remains-action.chaos_bolt.travel_time-5<duration*0.3)"
,"call_action_list,name=cds"
,"channel_demonfire"
,"havoc,cycle_targets=1,if=!(target=sim.target)&target.time_to_die>10"
,"havoc,if=active_enemies>1"
,"soul_fire,cycle_targets=1,if=!debuff.havoc.remains"
,"chaos_bolt,cycle_targets=1,if=!debuff.havoc.remains&execute_time+travel_time<target.time_to_die&(talent.internal_combustion.enabled|!talent.internal_combustion.enabled&soul_shard>=4|(talent.eradication.enabled&debuff.eradication.remains<=cast_time)|buff.dark_soul_instability.remains>cast_time|pet.infernal.active&talent.grimoire_of_supremacy.enabled)"
,"conflagrate,cycle_targets=1,if=!debuff.havoc.remains&((talent.flashover.enabled&buff.backdraft.stack<=2)|(!talent.flashover.enabled&buff.backdraft.stack<2))"
,"shadowburn,cycle_targets=1,if=!debuff.havoc.remains&((charges=2|!buff.backdraft.remains|buff.backdraft.remains>buff.backdraft.stack*action.incinerate.execute_time))"
,"incinerate,cycle_targets=1,if=!debuff.havoc.remains"

-- Cata
,"call_action_list,name=cds"
,"rain_of_fire,if=soul_shard>=4.5"
,"cataclysm"
,"immolate,if=talent.channel_demonfire.enabled&!remains&cooldown.channel_demonfire.remains<=action.chaos_bolt.execute_time"
,"channel_demonfire"
,"havoc,cycle_targets=1,if=!(target=sim.target)&target.time_to_die>10&spell_targets.rain_of_fire<=8&talent.grimoire_of_supremacy.enabled&pet.infernal.active&pet.infernal.remains<=10"
,"havoc,if=spell_targets.rain_of_fire<=8&talent.grimoire_of_supremacy.enabled&pet.infernal.active&pet.infernal.remains<=10"
,"chaos_bolt,cycle_targets=1,if=!debuff.havoc.remains&talent.grimoire_of_supremacy.enabled&pet.infernal.remains>execute_time&active_enemies<=8&((108*spell_targets.rain_of_fire%3)<(240*(1+0.08*buff.grimoire_of_supremacy.stack)%2*(1+buff.active_havoc.remains>execute_time)))"
,"havoc,cycle_targets=1,if=!(target=sim.target)&target.time_to_die>10&spell_targets.rain_of_fire<=4"
,"havoc,if=spell_targets.rain_of_fire<=4"
,"chaos_bolt,cycle_targets=1,if=!debuff.havoc.remains&buff.active_havoc.remains>execute_time&spell_targets.rain_of_fire<=4"
,"immolate,cycle_targets=1,if=!debuff.havoc.remains&refreshable&remains<=cooldown.cataclysm.remains"
,"rain_of_fire"
,"soul_fire,cycle_targets=1,if=!debuff.havoc.remains"
,"conflagrate,cycle_targets=1,if=!debuff.havoc.remains"
,"shadowburn,cycle_targets=1,if=!debuff.havoc.remains&((charges=2|!buff.backdraft.remains|buff.backdraft.remains>buff.backdraft.stack*action.incinerate.execute_time))"
,"incinerate,cycle_targets=1,if=!debuff.havoc.remains"

-- CDs
,"summon_infernal,if=target.time_to_die>=210|!cooldown.dark_soul_instability.remains|target.time_to_die<=30+gcd|!talent.dark_soul_instability.enabled"
,"dark_soul_instability,if=target.time_to_die>=140|pet.infernal.active|target.time_to_die<=20+gcd"
,"potion,if=pet.infernal.active|target.time_to_die<65"
,"berserking"
,"blood_fury"
,"fireblood"
,"use_items"

-- FNB
,"call_action_list,name=cds"
,"rain_of_fire,if=soul_shard>=4.5"
,"immolate,if=talent.channel_demonfire.enabled&!remains&cooldown.channel_demonfire.remains<=action.chaos_bolt.execute_time"
,"channel_demonfire"
,"havoc,cycle_targets=1,if=!(target=sim.target)&target.time_to_die>10&spell_targets.rain_of_fire<=4&talent.grimoire_of_supremacy.enabled&pet.infernal.active&pet.infernal.remains<=10"
,"havoc,if=spell_targets.rain_of_fire<=4&talent.grimoire_of_supremacy.enabled&pet.infernal.active&pet.infernal.remains<=10"
,"chaos_bolt,cycle_targets=1,if=!debuff.havoc.remains&talent.grimoire_of_supremacy.enabled&pet.infernal.remains>execute_time&active_enemies<=4&((108*spell_targets.rain_of_fire%3)<(240*(1+0.08*buff.grimoire_of_supremacy.stack)%2*(1+buff.active_havoc.remains>execute_time)))"
,"havoc,cycle_targets=1,if=!(target=sim.target)&target.time_to_die>10&spell_targets.rain_of_fire<=4"
,"havoc,if=spell_targets.rain_of_fire<=4"
,"chaos_bolt,cycle_targets=1,if=!debuff.havoc.remains&buff.active_havoc.remains>execute_time&spell_targets.rain_of_fire<=4"
,"immolate,cycle_targets=1,if=!debuff.havoc.remains&refreshable&spell_targets.incinerate<=8"
,"rain_of_fire"
,"soul_fire,cycle_targets=1,if=!debuff.havoc.remains&spell_targets.incinerate=3"
,"conflagrate,cycle_targets=1,if=!debuff.havoc.remains&(talent.flashover.enabled&buff.backdraft.stack<=2|spell_targets.incinerate<=7|talent.roaring_blaze.enabled&spell_targets.incinerate<=9)"
,"incinerate,cycle_targets=1,if=!debuff.havoc.remains"

-- Inf
,"call_action_list,name=cds"
,"rain_of_fire,if=soul_shard>=4.5"
,"cataclysm"
,"immolate,if=talent.channel_demonfire.enabled&!remains&cooldown.channel_demonfire.remains<=action.chaos_bolt.execute_time"
,"channel_demonfire"
,"havoc,cycle_targets=1,if=!(target=sim.target)&target.time_to_die>10&spell_targets.rain_of_fire<=4+talent.internal_combustion.enabled&talent.grimoire_of_supremacy.enabled&pet.infernal.active&pet.infernal.remains<=10"
,"havoc,if=spell_targets.rain_of_fire<=4+talent.internal_combustion.enabled&talent.grimoire_of_supremacy.enabled&pet.infernal.active&pet.infernal.remains<=10"
,"chaos_bolt,cycle_targets=1,if=!debuff.havoc.remains&talent.grimoire_of_supremacy.enabled&pet.infernal.remains>execute_time&spell_targets.rain_of_fire<=4+talent.internal_combustion.enabled&((108*spell_targets.rain_of_fire%(3-0.16*spell_targets.rain_of_fire))<(240*(1+0.08*buff.grimoire_of_supremacy.stack)%2*(1+buff.active_havoc.remains>execute_time)))"
,"havoc,cycle_targets=1,if=!(target=sim.target)&target.time_to_die>10&spell_targets.rain_of_fire<=3&(talent.eradication.enabled|talent.internal_combustion.enabled)"
,"havoc,if=spell_targets.rain_of_fire<=3&(talent.eradication.enabled|talent.internal_combustion.enabled)"
,"chaos_bolt,cycle_targets=1,if=!debuff.havoc.remains&buff.active_havoc.remains>execute_time&spell_targets.rain_of_fire<=3&(talent.eradication.enabled|talent.internal_combustion.enabled)"
,"immolate,cycle_targets=1,if=!debuff.havoc.remains&refreshable"
,"rain_of_fire"
,"soul_fire,cycle_targets=1,if=!debuff.havoc.remains"
,"conflagrate,cycle_targets=1,if=!debuff.havoc.remains"
,"shadowburn,cycle_targets=1,if=!debuff.havoc.remains&((charges=2|!buff.backdraft.remains|buff.backdraft.remains>buff.backdraft.stack*action.incinerate.execute_time))"
,"incinerate,cycle_targets=1,if=!debuff.havoc.remains"
]]
	end
	
end)
